#ifndef R2LP_H
#define R2LP_H

#include <stdint.h>

#include "mem.h"
#include "pft.h"
#include "rklp.h"

#define R2LP_K 2

typedef struct r2lp_struct
{
    // Per-group state bits
    volatile unsigned int S;
    unsigned int _buf1[15];

    // Two different reader phases
    rklp_group_t groups[R2LP_K];

} __attribute ((aligned (64) )) r2lp_t;

void r2lp_init(r2lp_t *lock);

uint64_t *r2lp_lock(r2lp_t *lock, unsigned int groupnum);
uint64_t *r2lp_unlock(r2lp_t *lock, unsigned int groupnum);

#endif // R2LP_H
