#ifndef R3LP_H
#define R3LP_H

#include <stdint.h>

#include "mem.h"
#include "pft.h"
#include "rklp.h"

#define R3LP_K 3

typedef struct r3lp_struct
{
    // Per-group state bits
    volatile unsigned int S;
    unsigned int _buf1[15];

    // Three different reader phases
    rklp_group_t groups[R3LP_K];

    // Potentially cache lock state to handle race condition on unlock
    rklp_cached_state_t cached_state[R3LP_K];

} __attribute ((aligned (64) )) r3lp_t;

void r3lp_init(r3lp_t *lock);

uint64_t *r3lp_lock(r3lp_t *lock, unsigned int groupnum);
uint64_t *r3lp_unlock(r3lp_t *lock, unsigned int groupnum);

#endif // R3LP_H
