#ifndef R9LP_H
#define R9LP_H

#include <stdint.h>

#include "mem.h"
#include "pft.h"
#include "rklp.h"

#define R9LP_K 9

typedef struct r9lp_struct
{
    // Per-group state bits
    volatile unsigned int S;
    unsigned int _buf1[15];

    // Nine different reader phases
    rklp_group_t groups[R9LP_K];

    // Potentially cache lock state to handle race condition on unlock
    rklp_cached_state_t cached_state[R9LP_K];

} __attribute ((aligned (64) )) r9lp_t;

void r9lp_init(r9lp_t *lock);

uint64_t *r9lp_lock(r9lp_t *lock, unsigned int groupnum);
uint64_t *r9lp_unlock(r9lp_t *lock, unsigned int groupnum);

#endif // R9LP_H
